//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "MainFrm.h"
#include "runge_kutt.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
double F(double x, double y)
{ return 1.002*x+0.5496*x*y-0.6540*sin(y*y); }
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
Edit2->Text = 0.1716;
Edit3->Text = 0;
Edit4->Text = 1;
Edit5->Text = 0.1;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BitBtn1Click(TObject *Sender)
{
Series1->Clear();

std::vector<Mathematics::pair_of_doubles> result;

double X0, Y0, Xmin, Xmax, h;
try {Y0 = Edit2->Text.ToDouble();}
catch(...)
 {
 MessageBox(NULL,"   Y0!",Application->Title.c_str(),MB_OK|MB_ICONERROR|MB_TOPMOST);
 Edit2->SetFocus();
 }
try {Xmin = Edit3->Text.ToDouble();}
catch(...)
 {
 MessageBox(NULL,"     !",Application->Title.c_str(),MB_OK|MB_ICONERROR|MB_TOPMOST);
 Edit3->SetFocus();
 }
try {Xmax = Edit4->Text.ToDouble();}
catch(...)
 {
 MessageBox(NULL,"     !",Application->Title.c_str(),MB_OK|MB_ICONERROR|MB_TOPMOST);
 Edit4->SetFocus();
 };
try {h = Edit5->Text.ToDouble();}
catch(...)
 {
 MessageBox(NULL,"     X!",Application->Title.c_str(),MB_OK|MB_ICONERROR|MB_TOPMOST);
 Edit5->SetFocus();
 };
if(Xmin>=Xmax)
 {
 MessageBox(NULL,"     X!",Application->Title.c_str(),MB_OK|MB_ICONERROR|MB_TOPMOST);
 Edit3->SetFocus();
 return;
 }
Mathematics::RungeKutt(Xmin,Y0,Xmax,h,F,result);

std::vector<Mathematics::pair_of_doubles>::iterator it  = result.begin();
std::vector<Mathematics::pair_of_doubles>::iterator end = result.end();
for(it;it!=end;++it)
 Series1->AddXY((*it).first,(*it).second);


}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Chart1DblClick(TObject *Sender)
{
if(Chart1->Legend->Visible == true)
 Chart1->Legend->Visible = false;
else
 Chart1->Legend->Visible = true;
}
//---------------------------------------------------------------------------
